/*
 * Copyright (c) 2002, Jason Tishler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * A copy of the GNU General Public License can be found at
 * http://www.gnu.org/
 *
 * Written by Jason Tishler <jason@tishler.net>
 *
 */

#ifndef _RebaseBuilder_h_
#define _RebaseBuilder_h_

#include <string>

class RebaseBuilder
{
public:
  RebaseBuilder ();
  ~RebaseBuilder ();

  virtual void buildVersion ();
  virtual void buildVersionEntry (const string &aVersion);
  virtual void buildFreeList ();
  virtual void buildFreeListEntry (unsigned long aBegin, unsigned long anEnd);
  virtual void buildUsedList ();
  virtual void buildUsedListEntry (const string &aPathname, unsigned long aBase,
				   unsigned long aSize);
};

#endif // _RebaseBuilder_h_
