/*
 * Copyright (c) 2002, Jason Tishler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * A copy of the GNU General Public License can be found at
 * http://www.gnu.org/
 *
 * Written by Jason Tishler <jason@tishler.net>
 */

#ifndef _RebaseFreeList_h_
#define _RebaseFreeList_h_

#include <set>

struct RebaseFreeListEntry;

class RebaseFreeList
{
public:
  RebaseFreeList ();
  ~RebaseFreeList ();

  void insert (unsigned long aBegin, unsigned long anEnd);
  bool remove (unsigned long anImageSize, unsigned long &aNewImageBase);
  void update (unsigned long aBegin, unsigned long anEnd);
  bool find (const RebaseFreeListEntry &anEntry) const;
  void print () const;

private:
  RebaseFreeList (const RebaseFreeList &rhs);
  RebaseFreeList& operator= (const RebaseFreeList &rhs);

  typedef set<RebaseFreeListEntry> FreeList;
  FreeList theFreeList;
};

struct RebaseFreeListEntry
{
  RebaseFreeListEntry (unsigned long aBegin, unsigned long anEnd);

  bool operator< (const RebaseFreeListEntry &rhs) const;

  unsigned long size;
  unsigned long begin;
  unsigned long end;
};
#endif // _RebaseFreeList_h_
