/*
 * Copyright (c) 2002, Jason Tishler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * A copy of the GNU General Public License can be found at
 * http://www.gnu.org/
 *
 * Written by Jason Tishler <jason@tishler.net>
 */

#include "RebaseMemoryBuilder.h"
#include "RebaseFreeList.h"
#include "RebaseUsedList.h"

RebaseMemoryBuilder::RebaseMemoryBuilder (RebaseFreeList &aFreeList,
					  RebaseUsedList &anUsedList) :
  theFreeList (aFreeList), theUsedList (anUsedList)
{
}

RebaseMemoryBuilder::~RebaseMemoryBuilder ()
{
}

void
RebaseMemoryBuilder::buildFreeListEntry (unsigned long aBegin,
    					 unsigned long anEnd)
{
  theFreeList.insert (aBegin, anEnd);
}

void
RebaseMemoryBuilder::buildUsedListEntry (const string &aPathname,
					 unsigned long aBase,
					 unsigned long aSize)
{
  theUsedList.insert (aPathname, aBase, aSize);
}
