/*
 * Copyright (c) 2002, Jason Tishler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * A copy of the GNU General Public License can be found at
 * http://www.gnu.org/
 *
 * Written by Jason Tishler <jason@tishler.net>
 */

#include <iostream>
#include <iomanip>
#include "RebaseUsedList.h"

RebaseUsedList::RebaseUsedList ()
{
}

RebaseUsedList::~RebaseUsedList ()
{
}

void
RebaseUsedList::insert (const string &aPathname, unsigned long aBase,
			unsigned long aSize)
{
  RebaseUsedListEntry anEntry (aPathname, aBase, aSize);
  theUsedList.insert (anEntry);
}

bool
RebaseUsedList::remove (const string &aPathname, unsigned long &aBase,
		        unsigned long &aSize)
{
}

bool
RebaseUsedList::find (const string &aPathname, unsigned long &aBase,
		      unsigned long &aSize) const
{
}

void
RebaseUsedList::print () const
{
  for (UsedList::iterator i = theUsedList.begin (); i != theUsedList.end ();
       i++)
    {
      const RebaseUsedListEntry &anEntry = (*i);
      cout << "pathname = " << anEntry.pathname << hex << ", base = " << "0x"
	<< setw (8) << setfill ('0') << anEntry.base << ", size = " << "0x" <<
	setw (8) << setfill ('0') << anEntry.size << endl;;
    }
}

RebaseUsedListEntry::RebaseUsedListEntry (const string &aPathname,
					  unsigned long aBase,
					  unsigned long aSize) :
  pathname (aPathname), base (aBase), size (aSize)
{
}

bool
RebaseUsedListEntry::operator< (const RebaseUsedListEntry &rhs) const
{
  return strcasecmp (pathname.c_str (), rhs.pathname.c_str ()) < 0;
}
