/*
 * Copyright (c) 2002, Jason Tishler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * A copy of the GNU General Public License can be found at
 * http://www.gnu.org/
 *
 * Written by Jason Tishler <jason@tishler.net>
 */

#ifndef _RebaseUsedList_h_
#define _RebaseUsedList_h_

#include <string>
#include <set>

struct RebaseUsedListEntry;

class RebaseUsedList
{
public:
  RebaseUsedList ();
  ~RebaseUsedList ();

  void insert (const string &aPathname, unsigned long aBase,
	       unsigned long aSize);
  bool remove (const string &aPathname, unsigned long &aBase,
	       unsigned long &aSize);
  bool find (const string &aPathname, unsigned long &aBase,
	     unsigned long &aSize) const;
  void print () const;

private:
  RebaseUsedList (const RebaseUsedList &rhs);
  RebaseUsedList& operator= (const RebaseUsedList &rhs);

  typedef set<RebaseUsedListEntry> UsedList;
  UsedList theUsedList;
};

struct RebaseUsedListEntry
{
  RebaseUsedListEntry (const string &aPathname, unsigned long aBase,
		       unsigned long aSize);

  bool operator< (const RebaseUsedListEntry &rhs) const;

  string pathname;
  unsigned long base;
  unsigned long size;
};
#endif // _RebaseUsedList_h_
