/*
 * Copyright (c) 2002, Jason Tishler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * A copy of the GNU General Public License can be found at
 * http://www.gnu.org/
 *
 * Written by Jason Tishler <jason@tishler.net>
 */

#include <string>
#include "RebaseConfigParser.h"
#include "RebaseConfigBuilder.h"
#include "RebaseMemoryBuilder.h"
#include "RebaseFreeList.h"
#include "RebaseUsedList.h"

int
main (int argc, char *argv[])
{
  const string aConfigFileName = argv[1];
  const string anOutConfigFileName = argv[2];

  RebaseFreeList aFreeList;
  RebaseUsedList anUsedList;
  RebaseMemoryBuilder aBuilder (aFreeList, anUsedList);
  RebaseConfigParser aParser (aConfigFileName);
  aParser.parse (aBuilder);
  aFreeList.print ();
  anUsedList.print ();

  RebaseConfigBuilder aBuilder2 (anOutConfigFileName);
  RebaseConfigParser aParser2 (aConfigFileName);
  aParser2.parse (aBuilder2);

  return 0;
}
